<?php

/**
 * @file
 * Contains \Drupal\easychart\EasychartHelper
 */

namespace Drupal\easychart;

class EasychartHelper {

  /**
   * Helper function to print the actual chart.
   *
   * @param array $values
   *   The field item values
   * @param int $entity_id
   *   The entity id
   * @param int $delta
   *   The delta
   *
   * @return string $output
   *   The field output.
   */
  public static function easychartPrintChart($values, $entity_id, $delta) {

    $output = [];

    // Verify csv being given.
    if (empty($values['csv'])) {
      return FALSE;
    }
    // Add JS for each instance when config is set.
    else {
      // Print a div for js to pick up & render chart.
      $output['markup'] = '<div class="easychart-embed--' . $entity_id . '-' . $delta . '"></div>';
      // Add config to output.
      $output['config'] = $values['config'];
      // Add csv to output.
      $output['csv'] = (!empty($values['csv'])) ? $values['csv'] : '';
    }
    return $output;
  }

  /**
   * Add libraries to render a chart.
   *
   * @param $element
   */
  public static function addRenderLibraries(&$element) {
    $element['#attached']['library'][] = 'easychart/easychart.render';
    $element['#attached']['library'][] = 'easychart/lib.highcharts';
    $element['#attached']['library'][] = 'easychart/lib.easycharts.minimal';
  }
}
